<?php

namespace App\Filament\Exports;

use App\Models\CheckPointTime;
use Filament\Actions\Exports\ExportColumn;
use Filament\Actions\Exports\Exporter;
use Filament\Actions\Exports\Models\Export;

class CheckPointTimeExporter extends Exporter
{
    protected static ?string $model = CheckPointTime::class;

    public static function getColumns(): array
    {
        static $rowNumber = 0;

        return [
            // ExportColumn::make('id')
            //     ->label('ID'),
            ExportColumn::make('no')
                ->label('NO')
                ->state(function ($record) use (&$rowNumber) {
                    // Increment and return the row number
                    return ++$rowNumber;
                }),
            ExportColumn::make('plant.name')
                ->label('PLANT'),
            ExportColumn::make('checkPointNames1.name')
                ->label('CHECK POINT 1'),
            ExportColumn::make('checkPointNames2.name')
                ->label('CHECK POINT 2'),
            ExportColumn::make('sequence_number')
                ->label('SEQUENCE NUMBER'),
            ExportColumn::make('time_lapse')
                ->label('TIME LAPSE'),
            ExportColumn::make('time_lapse_cushioning')
                ->label('TIME LAPSE CUSHIONING'),
            ExportColumn::make('created_at')
                ->label('CREATED AT'),
            ExportColumn::make('created_by')
                ->label('CREATED BY'),
            ExportColumn::make('updated_at')
                ->label('UPDATED AT'),
            ExportColumn::make('deleted_at')
                ->enabledByDefault(false)
                ->label('DELETED AT'),
        ];
    }

    public static function getCompletedNotificationBody(Export $export): string
    {
        $body = 'Your check point time export has completed and ' . number_format($export->successful_rows) . ' ' . str('row')->plural($export->successful_rows) . ' exported.';

        if ($failedRowsCount = $export->getFailedRowsCount()) {
            $body .= ' ' . number_format($failedRowsCount) . ' ' . str('row')->plural($failedRowsCount) . ' failed to export.';
        }

        return $body;
    }
}
